#include <qdir.h>
#include <iostream.h>
#include "StringToken.h"
#include "channelPage.h"
#include "ircView.h"
#include "channelTab.h"
#include "channelTab.moc"
#include "optIrcTab.h"    // coloropt, fontopt
#include "colorOpt.h"
#include "fontOpt.h"

#include <qlayout.h>

ChannelTab::ChannelTab(IrcClient* Client, IrcView* View, QWidget* parent, const char* Name):
  PageTab(Client, parent, Name)
{
  view    = View;
  connect(client, 
	  SIGNAL(signAddChannel(const char*, const char*)),
	  this,
	  SLOT  (slotAddChannel(const char*, const char*)));

  show();
}

ChannelTab::~ChannelTab()
{
#ifdef EDEBUG
  cout << "Destruktor ChannelTab" << endl;
#endif
}

void ChannelTab::slotAddChannel(const char* Channel, const char* Key)
{
  ChannelPage* cp;
  QString s=Channel;
  treeList->insertItem(s, 0, -1);
  page->insert(Channel, cp=new ChannelPage(client, panner->child1(), Channel));
  OptIrcTab* it=(OptIrcTab*)view->getTab("OptIrcTab");
  
  connect((ColorOpt*)it->getPage("Color"),
	  SIGNAL(colorsChanged(const QColor&, int)),
	  cp->ircHtml(),
	  SLOT  (slotSetColor (const QColor&, int))
	  );  
  connect((FontOpt*)it->getPage("Font"),
	  SIGNAL(signFontSize(int , int)),
	  cp->ircHtml(),
	  SLOT  (slotSetFontSize(int, int))
	  );
  connect((FontOpt*)it->getPage("Font"),
	  SIGNAL(signFontName(const char*, int)),
	  cp->ircHtml(),
	  SLOT  (slotSetFontName(const char*, int))
	  );
  connect(cp->channelClient(),
	  SIGNAL(signDelClient(const char*)),
	  this,
	  SLOT  (slotDelPage  (const char*))
	  );  
  connect(this,
	  SIGNAL(signCurrentPage(const char*)),
	  cp,
	  SLOT  (slotCurrentPage(const char*)));

  resize(width(), height());
  QWidget* w=topLevelWidget();
  if (!w->isVisible())
     w->show();

  KTreeListItem* item;
  for (int i=0;i<treeList->count();i++){
     item = treeList->itemAt(i);
     if (!stricmp(Channel, item->getText())){
        slotSetPage(i);
	return;
     }
  }
}

