#include <iostream.h>
#include "optPrefDialog.h"
#include "channelView.h"
#include "channelView.moc"
#include "channelPage.h"
#include "fontOpt.h"
#include "colorOpt.h"


ChannelView::ChannelView(IrcClient* client, QWidget* parent, const char* name ) : 
             PageTab(client, parent, name)
{
#ifdef EDEBUG
  cout << "Konstruktor ChannelView"<<endl;
#endif
   setFrameStyle(QFrame::Panel | QFrame::Sunken);
   setLineWidth (2);
   connect(client, 
	   SIGNAL(signAddChannel(const char*, const char*)),
	   this,
	   SLOT  (slotAddChannel(const char*, const char*)));
   show();
#ifdef EDEBUG
  cout << "Konstruktor ChannelView...Ok"<<endl;
#endif
}

ChannelView::~ChannelView()
{
#ifdef EDEBUG
  cout << "Destruktor ChannelView" << endl;
#endif
}

void ChannelView::closeEvent (QCloseEvent *)
{
}

void ChannelView::slotAddChannel(const char* Channel, const char* Key)
{
#ifdef EDEBUG
  cout << "ChannelView::slotAddChannel("<<Channel<<")"<<endl;
#endif

  ChannelPage* cp;
  QString s=Channel;
  treeList->insertItem(s, 0, -1);
  pageWidget->hide();
  cp=new ChannelPage(client, pageWidget, Channel);
  cp->vbox = new QVBoxLayout(pageWidget,0);
  cp->vbox->addWidget(cp);
  cp->vbox->activate();
  page->insert(Channel, cp);

  pageWidget->show();

  OptPrefDialog* dlg=client->optPrefDlg;
  connect((ColorOpt*)dlg->getPage("Color"),
	  SIGNAL(colorsChanged(const QColor&, int)),
	  cp->ircHtml(),
	  SLOT  (slotSetColor (const QColor&, int))
	  );  
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontSize(int , int)),
	  cp->ircHtml(),
	  SLOT  (slotSetFontSize(int, int))
	  );
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontName(const char*, int)),
	  cp->ircHtml(),
	  SLOT  (slotSetFontName(const char*, int))
	  );
  connect(cp->channelClient(),
	  SIGNAL(signDelClient(const char*)),
	  this,
	  SLOT  (slotDelPage  (const char*))
	  );  
  connect(this,
	  SIGNAL(signCurrentPage(const char*)),
	  cp,
	  SLOT  (slotCurrentPage(const char*)));

  QWidget* w=topLevelWidget();
  if (!w->isVisible())
     w->show();

  KTreeListItem* item;
  for (int i=0;i<treeList->count();i++){
     item = treeList->itemAt(i);
     if (!stricmp(Channel, item->getText())){
        slotSetPage(i);
	break;
     }
  }

#ifdef EDEBUG
  cout << "ChannelView::slotAddChannel.....Ok"<<endl;
#endif
}













