#ifndef __COLOROPT_H__
#define __COLOROPT_H__

#include <qwidget.h>
#include <qgrpbox.h>
#include <kconfig.h>

class ColorOpt : public QWidget
{
  Q_OBJECT
public:
  ColorOpt( QWidget *parent = NULL, const char *name = NULL );
  ~ColorOpt();

signals:
  void    colorsChanged( const QColor &col, int Type);
protected slots:
  void    slotBgColorChanged   (const QColor &col );
  void    slotTextColorChanged (const QColor &col );
  void    slotMsgColorChanged  (const QColor &col );
  void    slotInfoColorChanged (const QColor &col );
  void    slotErrorColorChanged  (const QColor &col );
  void    slotActionColorChanged (const QColor &col );

private:
  void    readOptions();

private:
  QColor bgColor;    // Background
  QColor textColor;  // my color
  QColor msgColor;   // Server msg Color
  QColor infoColor;  // link,vlink Color
  QColor actionColor;
  QColor errorColor;
};

#endif
