#include <iostream.h>
#include "StringToken.h"
#include "dccChatPage.h"
#include "ircView.h"
#include "dccChatTab.h"
#include "dccChatTab.moc"
#include "colorOpt.h"
#include "fontOpt.h"
#include "optPrefDialog.h"

#include <iostream.h>
#include <qlayout.h>

DCCChatTab::DCCChatTab(IrcClient* Client, QWidget* parent, const char* Name):
  PageTab(Client, parent, Name)
{
  connect(client, 
	  SIGNAL(signAddDCCChat(const char*)),
	  this,
	  SLOT  (slotAddDCCChat(const char*)));

  show();
}

DCCChatTab::~DCCChatTab()
{
#ifdef EDEBUG
  cout << "Destruktor DCCChatTab" << endl;
#endif
}

void DCCChatTab::slotAddDCCChat(const char* Name)
{
#ifdef EDEBUG
  cout << "DCCChatTab::slotAddDCCChat:" << Name<<endl;
#endif
  DCCChatPage* dcp;
  QString s=Name;
  treeList->insertItem(s, 0, treeList->currentItem());

  pageWidget->hide();

  page->insert(Name, dcp=new DCCChatPage(client, pageWidget, Name));
  dcp->vbox = new QVBoxLayout(pageWidget,0);
  dcp->vbox->addWidget(dcp);
  dcp->vbox->activate();

  pageWidget->show();

  OptPrefDialog* dlg=client->optPrefDlg;
  
  connect((ColorOpt*)dlg->getPage("Color"),
	  SIGNAL(colorsChanged(const QColor&, int)),
	  dcp->ircHtml(),
	  SLOT  (slotSetColor (const QColor&, int))
	  );  
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontSize(int , int)),
	  dcp->ircHtml(),
	  SLOT  (slotSetFontSize(int, int))
	  );
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontName(const char*, int)),
	  dcp->ircHtml(),
	  SLOT  (slotSetFontName(const char*, int))
	  );
  connect(dcp->getClient(), 
	  SIGNAL(signDelClient(const char*)),
	  this,
	  SLOT  (slotDelPage  (const char*)));
  connect(this,
	  SIGNAL(signCurrentPage(const char*)),
	  dcp,
	  SLOT  (slotCurrentPage(const char*)));

  QWidget* w=topLevelWidget();
  if (!w->isVisible())
     w->show();

  
  KTreeListItem* item;
  for (int i=0;i<treeList->count();i++){
     item = treeList->itemAt(i);
     if (!stricmp(Name, item->getText())){
        slotSetPage(i);
	return;
     }
  }
}









