#include <iostream.h>
#include "StringToken.h"
#include "dccChatPage.h"
#include "ircView.h"
#include "dccFileTab.h"
#include "dccFileTab.moc"
#include "colorOpt.h"
#include "fontOpt.h"
#include "optPrefDialog.h"

#include <iostream.h>
#include <qlayout.h>

DCCFileTab::DCCFileTab(IrcClient* Client, QWidget* parent, const char* Name):
  PageTab(Client, parent, Name)
{
  connect(client, 
	  SIGNAL(signAddDCCFile(const char*)),
	  this,
	  SLOT  (slotAddDCCFile(const char*)));

  show();
}

DCCFileTab::~DCCFileTab()
{
#ifdef EDEBUG
  cout << "Destruktor DCCFileTab" << endl;
#endif
}

void DCCFileTab::slotAddDCCFile(const char* Name)
{
#ifdef EDEBUG
  cout << "DCCFileTab::slotAddDCCFile:" << Name<<endl;
#endif
  DCCFilePage* dfp;
  QString s=Name;
  treeList->insertItem(s, 0, treeList->currentItem());
  
  pageWidget->hide();

  page->insert(Name, dfp=new DCCFilePage(client, pageWidget, Name));

  dfp->vbox = new QVBoxLayout(pageWidget,0);
  dfp->vbox->addWidget(dfp);
  dfp->vbox->activate();

  pageWidget->show();

  OptPrefDialog* dlg=client->optPrefDlg;
  
  connect((ColorOpt*)dlg->getPage("Color"),
	  SIGNAL(colorsChanged(const QColor&, int)),
	  dfp->ircHtml(),
	  SLOT  (slotSetColor (const QColor&, int))
	  );  
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontSize(int , int)),
	  dfp->ircHtml(),
	  SLOT  (slotSetFontSize(int, int))
	  );
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontName(const char*, int)),
	  dfp->ircHtml(),
	  SLOT  (slotSetFontName(const char*, int))
	  );
  connect(dfp->getClient(), 
	  SIGNAL(signDelClient(const char*)),
	  this,
	  SLOT  (slotDelPage  (const char*)));
  connect(this,
	  SIGNAL(signCurrentPage(const char*)),
	  dfp,
	  SLOT  (slotCurrentPage(const char*)));

  QWidget* w=topLevelWidget();
  if (!w->isVisible())
     w->show();

  
  KTreeListItem* item;
  for (int i=0;i<treeList->count();i++){
     item = treeList->itemAt(i);
     if (!stricmp(Name, item->getText())){
        slotSetPage(i);
	return;
     }
  }
}




