#include <iostream.h>
#include "htmlContent.h"
#include "htmlContent.moc"

HtmlContent::HtmlContent(KHTMLWidget* htmlw, int size)
{
  this->htmlw = htmlw;
  this->size  = size;
  curSize     = 0;
  buffer.setAutoDelete(true);
}

void HtmlContent::write(const char* txt)
{
#ifdef EDEBUG
  cout << "HtmlContent::write:"<<txt<<endl;
#endif
  if (curSize==0){
     start();
  }
  if (curSize < size){
     curSize++;
     buffer.append(txt);
     htmlw->write(txt);
  }
  else{
     emit signNextBuffer(txt);
  }
}

void HtmlContent::writeBuffer(const char* txt)
{
#ifdef EDEBUG
  cout << "HtmlContent::writeBuffer:"<<txt<<endl;
#endif
  curSize++;
  buffer.append(txt);
}

void HtmlContent::start(const char* url)
{
#ifdef EDEBUG
  cout << "HtmlContent::start:"<<endl;
#endif
  buffer.clear();
  curSize = 0;
  htmlw->begin();
  htmlw->parse();
  htmlw->write("<HTML><BODY>");
}

void HtmlContent::showHtml()
{
#ifdef EDEBUG
  cout << "HtmlContent::showHtml:"<<endl;
#endif
  htmlw->begin();
  htmlw->parse();
  htmlw->write("<HTML><BODY>");
  QString s;
  for (s=buffer.first();s;s=buffer.next())
      htmlw->write(s);
}

QStrList& HtmlContent::list()
{
  return buffer;
}



