#ifndef __IRCAPP_H__
#define __IRCAPP_H__

#include "kapp.h"
#include "remoteNetscape.h"
#include "webServer.h"

#define KEIRC_VERSION    "0.1"

#define ircapp IrcApp::ircApplication()

class IrcApp : public KApplication
{
public:
  static QString home;
  static QString keircHome;
  static QString entryGroup;
  WebServer* webServer;
  QDict<char>*     entryList;
  RemoteNetscape remoteNetscape;
  QString localHost;
public:
  IrcApp(int& argc, char** argv );
  ~IrcApp();
  static IrcApp* ircApplication(){
     return (IrcApp*)KApp;
  }
  QString readPathEntry (const char* Entry, const char* PathDefault);
  QString readListEntry (const char* Entry, const char* Default);
  void    writeListEntry(const char* Entry, const char* Value);
  int     readListEntry (const char* Entry, int Default);
  void    writeListEntry(const char* Entry, int Value);
  QString readEntry     (const char* Entry, const char* Default);
  int     readNumEntry  (const char* Entry, int Default);
  void    writeEntry(const char* Entry, const char* Value);
  void    writeEntry(const char* Entry, int Value);
  void    writeEntry(const char* Entry, const QColor& Value);
  int     browseInit();
  void    browse(const char*);
  void    browse(const char* cmd, const char* arg);
};

#endif
