#ifndef __IRCTOPWIDGET_H__
#define __IRCTOPWIDGET_H__

#include <qframe.h>
#include <qaccel.h>
#include <qmsgbox.h>
#include <ktopwidget.h>
#include <kconfig.h>
#include <ktoolbar.h>   
#include <kstatusbar.h>
#include <ktoolbar.h>
#include <qdict.h>
#include "ircClient.h"
#include "ircApp.h"

class IrcView;

class IrcTopWidget : public KTopLevelWidget
{
    Q_OBJECT;
public:
    IrcTopWidget(IrcClient* Client, QWidget* parent, const char *name=NULL);
    ~IrcTopWidget();

public slots:
     // Slot von Socket -> Statusbar
     void slotConnected   (IrcServer*);
     void slotDisconnected(IrcServer*);
     
     void slotCurNick  (const char* nick);
     void slotCurServer(IrcServer* is);
     void slotWindow(int id);

     void slotLiveStatus(IrcCore*);
     void slotLagging(const char*);

     void slotDCCChat();
     void slotDCCSend();
     void slotWindowPopup();

     void slotCtcpSound();
     void slotOptPref();
     void slotOptPrivMsg();
     void slotOptChannel();
     void slotOptDCC();
protected:
     void closeEvent  (QCloseEvent *e);
     void resizeEvent (QResizeEvent *);

private:
     void createMenu();
     void createStatusbar();
     void createToolbar  ();
protected:
     QString        name;
     IrcView*       ircView;
     QMenuBar*      menubar;
     QDict<QPopupMenu>  menu;
     KToolBar*      toolbar;
     KStatusBar*    statusbar;
     IrcClient*     client;
     QDict<QWidget>* window;

     int  idSbNick;
     int  idSbStatus;
     int  idSbLagging;
     int  idSbLive;
     int  idTbCounter;
     int  idTbMenu;
     int  idTbDCCChat;
     int  idTbDCCSend;
     int  idTbWindow;
};

#endif





