#include "ircUser.h"
#include "StringToken.h"

IrcUser::IrcUser(const char* nick, const char* user, const char* host):
  IrcCore(0, nick)
{
  if (!nick || !user || !host)
     return;

  mNick = nick;
  mUser = user;
  mHost = host;
  mInfo = "";
  mServer = "";
}

IrcUser::IrcUser(const char* name)
{
  StringToken st(name);
  QString nick, user, host;
  if (!(nick=st.nextToken(" !@")))
     return;
  setName(nick);
  if (!(user=st.nextToken()))
     user="";
  if (!(host=st.nextToken()))
     host="";
  mNick = nick;
  mUser = user;
  mHost = host;
  mInfo = "";
  mServer = "";
}

QString IrcUser::toName()
{
  return mNick+"!"+mUser+"@"+mHost;
}


