#ifndef __IRCUSER_H__
#define __IRCUSER_H__ 

#include <qstring.h>
#include "ircCore.h"

class IrcUser : public IrcCore
{
protected:
  QString mNick;
  QString mUser;
  QString mHost;
  QString mInfo;
  QString mServer;
public:
  IrcUser(const char* nick, const char* user, const char* host);
  IrcUser(const char* name);   // ~nick!user@host
  QString toName ();
  QString nick(){return mNick;}
  QString user(){return mUser;}
  QString host(){return mHost;}
  QString info(){return mInfo;}
  QString server(){return mServer;}
  void setNick(const char* s){
    mNick = s;
  }
  void setUser(const char* s){
    mUser = s;
  }
  void setHost(const char* s){
    mHost = s;
  }
  void setInfo(const char* s){
    mInfo = s;
  }
  void setServer(const char* s){
    mServer = s;
  }
};

#endif

