#include <iostream.h>
#include "ircView.h"
#include "ircView.moc"
#include "ircMsgPage.h"
#include "webServerPage.h"
#include <qlayout.h>

IrcView::IrcView(IrcClient* client, QWidget* parent, const char* name ) : 
  QFrame(parent, name)
{
#ifdef EDEBUG
  cout << "Konstruktor IrcView" << endl;
#endif
   this->client = client;
   setFrameStyle(QFrame::Panel | QFrame::Sunken);
   setLineWidth(2);
   tabCtl           = new KTabCtl(this);
   tab.setAutoDelete(FALSE);
   wid.setAutoDelete(FALSE);

   QWidget* w;
   wid.insert("IrcTab", w = new QWidget(tabCtl));
   tab.insert("IrcTab", ircTab = new IrcTab(client, w));
   tabCtl->addTab(w,  "Server MSG");

   wid.insert("ClientSetupTab", w = new QWidget(tabCtl));
   tab.insert("ClientSetupTab", clientSetupTab = new ClientSetupTab(client, w));
   tabCtl->addTab(w, "Client Setup");

   connect(tabCtl,
	   SIGNAL(tabSelected(int)),
	   this,
	   SLOT  (slotTabSelected(int)));

   IrcMsgPage* imp = (IrcMsgPage*)ircTab->getPage("Irc Msg");

   if (imp){
      connect((ColorOpt*)client->optPrefDlg->getPage("Color"),
	      SIGNAL(colorsChanged(const QColor&, int)),
	      imp->ircHtml(),
	      SLOT  (slotSetColor (const QColor&, int))
	      );  
      connect((FontOpt*)client->optPrefDlg->getPage("Font"),
	      SIGNAL(signFontSize(int , int)),
	      imp->ircHtml(),
	      SLOT  (slotSetFontSize(int, int))
	      );
      connect((FontOpt*)client->optPrefDlg->getPage("Font"),
	      SIGNAL(signFontName(const char*, int)),
	      imp->ircHtml(),
	      SLOT  (slotSetFontName(const char*, int))
	      );
   }
   
   WebServerPage* wsp = (WebServerPage*)ircTab->getPage("Web Server");
   if (wsp){
      connect((ColorOpt*)client->optPrefDlg->getPage("Color"),
	      SIGNAL(colorsChanged(const QColor&, int)),
	      wsp->ircHtml(),
	      SLOT  (slotSetColor (const QColor&, int))
	      );  
      connect((FontOpt*)client->optPrefDlg->getPage("Font"),
	      SIGNAL(signFontSize(int , int)),
	      wsp->ircHtml(),
	      SLOT  (slotSetFontSize(int, int))
	      );
      connect((FontOpt*)client->optPrefDlg->getPage("Font"),
	      SIGNAL(signFontName(const char*, int)),
	      wsp->ircHtml(),
	      SLOT  (slotSetFontName(const char*, int))
	      );
   }

   show();
#ifdef EDEBUG
  cout << "Konstruktor IrcView...Ok" << endl;
#endif
}

IrcView::~IrcView()
{
#ifdef EDEBUG
  cout << "Destruktor IrcView" << endl;
#endif
}

void IrcView::slotTabSelected(int Tab)
{
  if (Tab==0){
     
  //ircTab->ircLine()->setFocus();
  }
}

void IrcView::resizeEvent(QResizeEvent*)
{
  tabCtl->resize   (width(),height());
  ircTab->setGeometry  (0, 
			0,
			wid["IrcTab"]->width()-0, 
			wid["IrcTab"]->height()-0);
  clientSetupTab->setGeometry(0, 
			      0, 
			      wid["ClientSetupTab"]->width()-0, 
			      wid["ClientSetupTab"]->height()-0);
			   
}

QWidget* IrcView::getTab(const char* Name)
{
  return tab.find(Name);
}











