#ifndef __IRCVIEW_H__
#define __IRCVIEW_H__

#include <qframe.h>
#include <qcombo.h>
#include <qpushbt.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qstrlist.h>
#include "ktabctl.h"
#include "ircClient.h"
#include "clientSetupTab.h"
#include "ircTab.h"
#include "colorOpt.h"
#include "fontOpt.h"
#include "kChannel.h"

class IrcView : public QFrame
{
  Q_OBJECT
public:
  IrcView (IrcClient* client, QWidget* parent=NULL, const char* name=NULL);
  ~IrcView();
public slots:
   void slotTabSelected(int page);
protected:
   void resizeEvent(QResizeEvent *);
signals:
   void signIrcClient     (IrcClient*  ircClient);
public:
   KTabCtl*        tabCtl;
   QDict<QWidget>  wid;
   QDict<QWidget>  tab;
   IrcTab*         ircTab;
   ClientSetupTab* clientSetupTab;
   QWidget*        getTab(const char* Name);
private:
   IrcClient* client;
};

#endif



