#ifndef __OUTPUTPAGE_H__
#define __OUTPUTPAGE_H__

#include "ircClient.h"
#include <qdict.h>
#include <qframe.h>
#include <qlistbox.h>
#include <ktoolbar.h>
#include <qpopmenu.h>
#include <qmenubar.h>
#include <knewpanner.h>
#include <qlined.h> 
#include <qlayout.h> 
#include "ircHtml.h"
#include "ircLine.h"
#include "ircDefine.h"

class OutputPage : public QFrame
{
  Q_OBJECT
protected:
  static int barHeight;
  IrcClient*  client;
  QWidget*    outWidget;
  QWidget*    panWidget;
  KNewPanner* panner;
  KToolBar*   toolbar;
  IrcHtml*    htmlMsg;
  IrcLine*    inpCmd;

  QVBoxLayout*      topLayout;
  QDict<QPopupMenu> menu;
  QString currentPage;
protected:
  virtual void resizeEvent(QResizeEvent* e);
  void createPopup();
  void createToolbar();
  void initAll();
signals:
  void signSetFlag(int Type, bool value);
public slots:
  void slotToolbarMoved();
  void slotInputPopup(const QPoint&);
  void slotInputPopupAction(const char*);
  void slotCurrentPage(const char*);
  virtual void slotBack();
  virtual void slotForward();
  virtual void slotEditCopy();
  void slotToggleLog (bool);
  void slotHtmlClear();
  virtual void slotWriteOnActive(int type, const char* txt, bool Filter);
public:
  OutputPage(IrcClient* Client, QWidget* parent, const char* Name=NULL);
  virtual ~OutputPage();
  IrcHtml*         ircHtml();
  IrcLine*         ircLine();

protected:
  int idTbCounter;
  int idTbBack;
  int idTbForward;
  int idTbClear;
  int idTbLog;
  int idTbExit;
public:
  QVBoxLayout* vbox;
};

#endif 



