#include <iostream.h>
#include "ircView.h"
#include "privMsgView.h"
#include "privMsgView.moc"
#include "optPrefDialog.h"
#include "privMsgPage.h"
#include "fontOpt.h"
#include "colorOpt.h"


PrivMsgView::PrivMsgView(IrcClient* client, QWidget* parent, const char* name ) : 
             PageTab(client, parent, name)
{
   this->client = client;
   setFrameStyle(QFrame::Panel | QFrame::Sunken);
   setLineWidth (2);
   connect(client, 
	  SIGNAL(signAddPrivMsg(const char*)),
	  this,
	  SLOT  (slotAddPrivMsg(const char*)));

   show();
}

PrivMsgView::~PrivMsgView()
{
#ifdef EDEBUG
  cout << "Destruktor PrivMsgView" << endl;
#endif
}

void PrivMsgView::slotAddPrivMsg(const char* Name)
{
  if (!Name)
     return;
#ifdef EDEBUG
  cout << "PrivMsgView::slotAddPrivMsg:" << Name<<endl;
#endif
  slotDelPage(Name);
  PrivMsgPage* pp;
  
  QString s=Name;
  treeList->insertItem(s, 0, treeList->currentItem());
  pageWidget->hide();
  pp=new PrivMsgPage(client, pageWidget, Name);
  pp->vbox = new QVBoxLayout(pageWidget,0);
  pp->vbox->addWidget(pp);
  pp->vbox->activate();
  pageWidget->show();
  page->insert(Name, pp);
  OptPrefDialog* dlg=client->optPrefDlg;
  
  connect((ColorOpt*)dlg->getPage("Color"),
	  SIGNAL(colorsChanged(const QColor&, int)),
	  pp->ircHtml(),
	  SLOT  (slotSetColor (const QColor&, int))
	  );  
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontSize(int , int)),
	  pp->ircHtml(),
	  SLOT  (slotSetFontSize(int, int))
	  );
  connect((FontOpt*)dlg->getPage("Font"),
	  SIGNAL(signFontName(const char*, int)),
	  pp->ircHtml(),
	  SLOT  (slotSetFontName(const char*, int))
	  );
  connect(pp->getClient(), 
	  SIGNAL(signDelClient(const char*)),
	  this,
	  SLOT  (slotDelPage  (const char*)));
  connect(pp->getClient(), 
	  SIGNAL(signChangeNick(const char*, const char*)),
	  this,
	  SLOT  (slotChangeItemName(const char*, const char*)));
  connect(this,
	  SIGNAL(signCurrentPage(const char*)),
	  pp,
	  SLOT  (slotCurrentPage(const char*)));

  QWidget* w=topLevelWidget();
  if (!w->isVisible())
     w->show();

  
  KTreeListItem* item;
  for (int i=0;i<treeList->count();i++){
     item = treeList->itemAt(i);
     if (!stricmp(Name, item->getText())){
        slotSetPage(i);
	return;
     }
  }
}


void PrivMsgView::closeEvent (QCloseEvent *)
{
#ifdef EDEBUG
  cout << "PrivMsgView::CloseEvent" << endl;
#endif
}













