bind ctcp -  version  ctcp:version
bind ctcp -  sound    ctcp:sound
bind dcc  -  send     dcc:checkfile
bind dcc  -  send     dcc:checkaddr


proc away {text } {
    global awaytext
    set awaytext $text
    writeactive 8 "Away will be activated: $text"
    bind timer   + 60 timer:away
    sendraw "AWAY :$text"
    
}

proc unaway { } {
    unbind timer    + 60  *
    sendraw "AWAY"
}

proc timer:away { } {
    global awaytext
    set clist [chanlist]
    foreach c $clist {
	sendctcp $c "ACTION $awaytext"
    }
}

proc ctcp:version {n to user cmd args} {
    sendctcpreply $n "SCRIPT TCL Script for keirc v 0.1"
}

proc ctcp:sound {n to user args} {
    set sdir [getopt CTCPSoundDir]
    set cmd  [lindex $args 0]
    set fn   [lindex $args 1]
    set fok  [file exists $sdir/$fn]
    if {$fok=="0"} {
	sendnotice $n "Sorry, i dont have file $fn" 
	return 1;
    }
    return 0;
}

proc dcc:checkfile {n cmd user args} {
    set file [lindex $args 0]
    if {$file=="script.ini"} {
	writeactive 8 "dcc script.ini from $user detected"
	sendnotice $n "What are u doing, dont play with fire..."
	return 1
    } 
}


proc dcc:checkaddr {n cmd user args} {
    set addr [lindex $args 1]
    if {string match $addr "-9*"} {
	writeactive 8 "Low-Level exploit attempt from $user detected"
	sendnotice $n "What are u doing, dont play with fire..."
	return 1
    } elseif {string match $addr "15097*"} {
	writeactive 8 "Advanced exploit attempt from $user detected"
	sendnotice $n "What are u doing, dont play with fire..."
	return 1
    } 
}



